local agent_helper = require(AGENT_PATH .. "agent_helper")

function PlatformAdapter:OpenExitDialog()
	agent_helper:Exit(function(result) 
		if "true" == result then
			Log("====OpenExitDialog====")
			AdapterToLua:endGame()
		end
	end)
end


AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
    login_verify_url = "cls.mg05.youyannet.com/ap7/login_verify.php",
	uid = "",
}

--初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ap7OUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
	--浮标里按“切换账号”
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "ap7"
end
-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "ap7_" .. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return "热血寻仙"
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/logo.png"
end

function AgentAdapter:Login(callback)

	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登陆回调 

end

function AgentAdapter:OnClickBackLogin()
	local callback = function()
		AgentLoginView:OnClickBtnLogin()--重新调出登陆界面
    end
    --自己按“返回”切换账号
	PlatformBinder:JsonCall("call_agent_logout2", "", "", LUA_CALLBACK(self, callback))
end

function AgentAdapter:LoginCallback(result)--登陆后回调
	Log("result===" .. result)

	local json_obj = cjson.decode(result)	

	if nil == json_obj or 
		nil == json_obj.uid  or 
		nil == json_obj.token 
		then return end

	local uid = json_obj.uid
	local token = json_obj.token

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		self:ShowFloatButton()--浮标
	end

	self.is_login_verify_ing = true
	local now_server_time = math.floor(GLOBAL_CONFIG.server_info.server_time + (Status.NowTime - GLOBAL_CONFIG.client_time))
	local real_url = string.format("%s?spid=%s&uid=%s&token=%s", self.login_verify_url, self:GetSpid(), uid, token)
	Log("log_real_url==" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end

function AgentAdapter:LogoutCallback(result)--注销回调
	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
	return true
end

function AgentAdapter:UIEventCallback(event)--UI事件回调
	if "open" == event then
		--self:ShowFloatButton()
	elseif "close" == event then
		--self:ShowFloatButton()
	end
	return true
end


function AgentAdapter:ShowFloatButton()--显示浮动按钮
	agent_helper:ShowFloatButton()
end



function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买

	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end

	local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local role_name = role_vo.name --角色名字
	local role_id = tostring(role_vo.role_id) --角色id
	local grade = tostring(role_vo.level) or "0" --角色等级	

	local param_obj = {}


	if RoleData.Instance and RoleData.Instance.role_info then
		param_obj.surplus_gold = RoleData.Instance.role_info.gold or "0" --角色元宝余额
	else
		param_obj.surplus_gold = "0"
	end

	local orderId = server_id .. "_" .. self.uid .. "_" .. os.time().."_"..role_id.."_"..grade.."_"..param_obj.surplus_gold

	param_obj.amount = amount
	param_obj.orderId = orderId
	param_obj.serverid = server_id



	Log("param_obj==" .. cjson.encode(param_obj))
	agent_helper:Pay(cjson.encode(param_obj), nil)
end



-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)
	self:SubmitInfo("creatRole")
end

-- 进入游戏上报
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo("enterServer")
end

--  升级上报
function AgentAdapter:ReportOnRoleLevUp(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo("levelUp")
end

function AgentAdapter:SubmitInfo(sub_type)
	local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

	if role_vo ~= nil and user_vo ~= nil then

		Log("submitInfo=start======")

		local info = {}
		info.sub_type = sub_type
		info.uid = self.uid
		info.goods_name = "元宝" --商品名字
		info.service = tostring(user_vo.plat_server_id) --服务器id
		info.server_name = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name --服务器id + 服务器名字
		info.role = role_vo.name --角色名字
		info.role_id = tostring(role_vo.role_id) --角色id
		info.grade = tostring(role_vo.level) or "0" --角色等级
		info.vip_level = tostring(role_vo.vip_level) or "0" --vip

		if RoleData.Instance and RoleData.Instance.role_info then
			info.gold = RoleData.Instance.role_info.gold or "0" --角色元宝余额
			info.party_name = RoleData.Instance.role_vo.guild_name or "无" --帮派

			if info.party_name == "" then
				info.party_name = "无"
			end
		else
			info.gold = "0"
			info.party_name = "无"
		end
		
		agent_helper:SubmitExtendData(cjson.encode(info))
		Log("submitInfo=end======" .. cjson.encode(info))

	end
end



--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end

