local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
	login_verify_url = "cls.mg05.youyannet.com/by2/login_verify.php",
	pay_verify_url = "http://thirdpay.eyouwx.com/thirdpay/yijieSync.action",
	uid = "",
	channle = "",
}

--退出--按返回键，首先是来到这里的
function PlatformAdapter:OpenExitDialog()
	agent_helper:Exit(function(result)--调java
		if "true" == result then
			AdapterToLua:endGame()
		else
			local format = { title = "退出", message = "退出游戏?", positive = "确定", negative = "取消", }
			self:OpenAlertDialog(format, function (result) if "positive" == result then 
				AdapterToLua:endGame()
			end end)
		end
	end)
end

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end
	local cache_data = Split((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), "_")
	if cache_data ~= nil then
		GLOBAL_CONFIG.package_info.config.agent_id = cache_data[1] or "by2"
		self.uid = cache_data[2] or ""
	end

	self.is_init = true
	AgentMs:InitLocalPush()
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return GLOBAL_CONFIG.package_info.config.agent_id
end

function AgentAdapter:GetChannelId()
	return "by2"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid() .. "_" .. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return "青云"
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/logo.png"
end

function AgentAdapter:Login(callback)


	local channel_id = PlatformBinder:JsonCall("call_get_channelId") or ""
	Log("channel_id=====11111======" .. channel_id)
	self:SetChanneId(channel_id)
	Log("GLOBAL_CONFIG.package_info.config.agent_id==========" .. GLOBAL_CONFIG.package_info.config.agent_id)



	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登录回调 

end

function AgentAdapter:OnClickBackLogin()
	PlatformBinder:JsonCall("call_agent_logout")
end

function AgentAdapter:OnClickRestartGame()
	PlatformBinder:JsonCall("call_agent_logout")
end

function AgentAdapter:LoginCallback(result)--登录后回调
	local json_obj = cjson.decode(result)
	local sdk = json_obj.sdk
	local uin = json_obj.uin
	local sess = json_obj.sess
	local app = json_obj.app

	self.channle = json_obj.channle



	local verify_callback = function(url, arg, data, size)
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		agent_helper:ShowFloatButton()
	end

	self.is_login_verify_ing = true
	
	local real_url = string.format("%s?spid=%s&device=%s&sdk=%s&uin=%s&sess=%s&app=%s&channle=%s", self.login_verify_url, self:GetSpid(), tostring(PlatformAdapter.GetPhoneUniqueId()), sdk, uin, sess, app,self.channle)
	Log("log_real_url====" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
end

function AgentAdapter:LogoutCallback(result)--注销回调
	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()--跳到登录界面
	end
	return true
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买
	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end
	local CpOrderId = self.channle .. "||" .. self.uid .. "||" .. server_id .. "_" .. self:GetPlatName() .. "_" .. os.time()
	local param_obj = {}

	param_obj.unitPrice = amount * 10
	param_obj.itemName = "元宝"
	param_obj.count = 0.1 * 100
	param_obj.callBackInfo = CpOrderId
	param_obj.callBackUrl = self.pay_verify_url
	agent_helper:Pay(cjson.encode(param_obj), nil)

end

-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)
	self.createRole = true
	self:SubmitInfo(0)
end

-- 进入游戏上报
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	if self.subit_date_tf == nil and self.createRole == nil then
		self.subit_date_tf = true
		self:SubmitInfo(1)
	end
	
end

--  升级上报
function AgentAdapter:ReportOnRoleLevUp(role_id, role_name, role_level, zone_id, zone_name)
	print("ReportOnRoleLevUp===========")
	self.roleLevelMTime = os.time()
	self:SubmitInfo(2)
end


function AgentAdapter:SubmitInfo(type_x)
	local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

		-- String server_id = json_obj.getString("server_id");          
	 --    String server_name = json_obj.getString("server_name");  
	 --    String role_name = json_obj.getString("role_name");  
	 --    String role_id = json_obj.getString("role_id"); 
	 --    String user_level = json_obj.getString("user_level");

	if role_vo ~= nil and user_vo ~= nil then
		local info = {}
		info.server_id = tostring(user_vo.plat_server_id)
		info.server_name = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
		info.role_name = role_vo.name
		info.role_id = tostring(role_vo.role_id)
		info.user_level = tostring(role_vo.level) or "0"
		--上报创建角色时间
		info.roleCTime = role_vo.create_time or 0
		--升级上报时间
		if type_x == 2 then
			info.roleLevelMTime = self.roleLevelMTime
		end

		print("SubmitInfo==" .. cjson.encode(info))
		agent_helper:SubmitExtendData(cjson.encode(info))
	end
end


--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end


channelIds = {}
channelIds["{81AB24E2-162D54BC}"] = "z01"--联想
channelIds["{B4447B49-BC295EFE}"] = "z02"	--豌豆荚
channelIds["{C826E32D-4F9C1C68}"] = "z03"	--华为
channelIds["{0993AC81-D95D4E48}"] = "z04"	--金立
channelIds["{164B940D-82A0EC42}"] = "z05"	--OPPO
channelIds["{3CBECEB4-C84C816E}"] = "z06"	--搜狗
channelIds["{48FA26AE-A2335CF1}"] = "z07"	--掌阅
channelIds["{5EFCB428-547E62B1}"] = "z08"	--VIVO(步步高)
channelIds["{5F9E9900-D9CCC2D0}"] = "z09"	--酷派

channelIds["{81D1B69A-A649FF51}"] = "z10"	--爱贝
channelIds["{90636300-3FC9CACC}"] = "z11"	--虫虫游戏
channelIds["{A2D2F4AE-D400E281}"] = "z12"	--安智市场
channelIds["{F52F35C5-A04A1876}"] = "z13"	--九游UC
channelIds["{00B0119C-64E63697}"] = "z14"	--点游联运


channelIds["{A7DE0BFE-7DA2AA8A}"] = "z15"	--啪啪游戏厅
channelIds["{B2E86127-33F723DA}"] = "z16"	--朋友玩
channelIds["{FC4E6E21-6C90ACDE}"] = "z17"	--惠游
channelIds["{57ADC33A-8E62A919}"] = "z18"	--PPS
channelIds["{7C54FDC5-8CCAF159}"] = "z19"	--九趣
channelIds["{881CD236-6F0545FF}"] = "z20"	--青柠

channelIds["{FED99454-AA91865E}"] = "z21"	--8808wan
channelIds["{D3CC11CD-6781F533}"] = "z22"	--云顶
channelIds["{A58AFC6D-D426DB29}"] = "z23"	--云霄堂
channelIds["{381E58DB-8C72A67C}"] = "z24"	--游戏fan
channelIds["{14A1382E-C59A6F70}"] = "z25"	--果盘

-- --分渠道  特殊处理
function AgentAdapter:SetChanneId(channeld)
	Log("channeld======22222========" .. channeld)

	GLOBAL_CONFIG.package_info.config.agent_id = channelIds[channeld] or "by2"
	MainProber.agent_id = GLOBAL_CONFIG.package_info.config.agent_id
	print("channeld==", GLOBAL_CONFIG.package_info.config.agent_id)
end
