local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
	login_verify_url = "cls.mg05.youyannet.com/azq/login_verify.php",
	creat_order_url = "cls.mg05.youyannet.com/azq/create_order.php",
	uid = "",
}

--重写退出界面
-- local format = { title = "退出", message = "退出游戏?", positive = "确定", negative = "取消", }

-- 	self:OpenAlertDialog(format, function (result) if "positive" == result then 

-- 			agent_helper:Exit(function(result) 
-- 				if "true" == result then
-- 					AdapterToLua:endGame()
-- 				end
-- 			end)

-- end end)

--退出
function PlatformAdapter:OpenExitDialog()
	agent_helper:Exit(function(result)
		if "true" == result then
			AdapterToLua:endGame()
		end
	end)
end

-- 初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()

	--浮标的切换账号，用这个方法来返回到登陆界面
	agent_helper:LogoutFloat(function(result)
		self:LogoutCallback(result)
		return true
	end)

end

-- 平台ID
function AgentAdapter:GetSpid()
	return "azq"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "azq_".. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[65]
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/logo.png"
end

function AgentAdapter:Login(callback)
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登录回调 

end

function AgentAdapter:OnClickBackLogin()
	local callback = function()
		AgentLoginView:OnClickBtnLogin()--重新调出登录界面
    end
    --自己按“返回”切换账号
	PlatformBinder:JsonCall("call_agent_logout_backbutton", "", "", LUA_CALLBACK(self, callback))
end

function AgentAdapter:LoginCallback(result)--登录后回调

	local json_obj = cjson.decode(result)

	self.UserId = json_obj.UserId
	self.SessionId = json_obj.SessionId
	self.platformId = json_obj.platformId

	Log("UserId=="..self.UserId)

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		self.account = ret_t.user.account
		self.accid = ret_t.user.accid

		agent_helper:ShowFloatButton()
	end

	self.is_login_verify_ing = true
	
	local real_url = string.format("%s?spid=%s&device=%s&UserId=%s&SessionId=%s&platformId=%s", self.login_verify_url, self:GetSpid(), tostring(PlatformAdapter.GetPhoneUniqueId()), self.UserId,self.SessionId,self.platformId)
	Log("log_real_url====" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end

function AgentAdapter:LogoutCallback(result)--注销回调

	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()--返回到登陆界面
	end
	return true
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买

	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end
	local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

	local game_order = server_id .. "_" .. self:GetPlatName() .. "_" .. os.time()
	local param_obj = {}
	param_obj.game_order = game_order   --透传参数，订单号
	param_obj.role_id = role_id     --角色id
	param_obj.role_name = role_name   --角色名字
	param_obj.amount = amount*100      --金额（分）
	param_obj.goodsnumb = amount*10      --元宝数量
	param_obj.server_id = server_id   --服务器id
	param_obj.notice_url = "http://cls.mg05.youyannet.com/azq/pay.php"   --支付回调
	param_obj.goods_id = 0   --商品ID
	param_obj.goods_name = "元宝"   --商品名称
	param_obj.goods_desc = 10*amount.."元宝"   --商品描述
	param_obj.ext = self.platformId  --拓展数据
	param_obj.session = self.SessionId
	param_obj.account = self.account
	param_obj.accid = self.accid
	param_obj.server_name = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name --服务器id + 服务器名字
	param_obj.user_level = tostring(role_vo.level) or "0" --角色等级
	param_obj.vip_level = tostring(role_vo.vip_level) or "0" --vip

	if RoleData.Instance and RoleData.Instance.role_info then
		param_obj.gold = RoleData.Instance.role_info.gold or "0" --角色元宝余额
		param_obj.party_name = RoleData.Instance.role_vo.guild_name --帮派
		if param_obj.party_name =="" then
			param_obj.party_name = "无"
		end
	else
		param_obj.gold = "0"
		param_obj.party_name = "无"
	end

 -- account	否	登陆验证返回的account
 -- accid	是	登陆验证返回的accid
 -- session	否	渠道session或者access_token
 -- game_order	是	游戏订单号
 -- amount	是	实际价格 单位：分
 -- notice_url	是	回调地址
 -- server_id	是	充值的目标服务器
 -- role_id	是	角色ID
 -- role_name	是	角色名称
 -- goods_id	是	商品ID，部分渠道充值以该id为标示，如联想
 -- goods_name	是	商品名称
 -- goods_desc	是	商品描述
 -- ext	否	扩展数据（如没特殊说明，该字段在充值回调时原样回传）
 -- sign	是	参考“6签名算法”

--生成订单链接串
	local str = ""
	for i,v in pairs(param_obj) do
	  str = str..i.."="..v.."&"
	end
	str = string.sub(str,0,-2)

--创建订单回调
 	local verify_callback = function(url, arg, data, size)

 		--Log("AgentAdapter:Pay======" .. data)

 		-- "data": {"accid": "293357835", "account": "zqw859906245"
 		--  "notice_url": "http://uni.zqbconnect.com/102334211/1/pay_notice", 
 		--  "goods_name": "\u5143\u5b9d", "goods_id": "0", 
 		--  "game_order": "1_azq_zqw859906245_1469179492", 
 		--  "ext": "1", "goods_desc": "10\u5143\u5b9d", 
 		--  "server_id": "1", "role_id": "1048578", "amount": "100",
 		--   "session": "93eb30e89a1971cd6132e79d0e99de010a3d25f8", 
 		--   "create_time": "20160722172614", "role_name": "\u80e1\u68c2\u77e2", 
 		--   "sign": "", "plat_order": ""}}

 		local ret_t = cjson.decode(data)

 		print("create_time=="..ret_t.data.create_time)
		param_obj.create_time = ret_t.data.create_time--创建时间

		agent_helper:Pay(cjson.encode(param_obj))

	end

--请求php创建订单
	local order_url = string.format("%s?%s", self.creat_order_url, str)
	Log("creat_order_url====" .. order_url)
	HttpClient:Request(order_url, "", verify_callback)

end

-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)
	self:SubmitInfo(0)
end

-- 进入游戏上报
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo(1)
end

--  升级上报
function AgentAdapter:ReportOnRoleLevUp(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo(2)
end

function AgentAdapter:SubmitInfo(sub_type)
	local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

	if role_vo ~= nil and user_vo ~= nil then

		Log("submitInfo=start======")

		local info = {}
		info.sub_type = sub_type
		info.goods_name = "元宝" --商品名字
		info.server_id = tostring(user_vo.plat_server_id) --服务器id
		info.server_name = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name --服务器id + 服务器名字
		info.role_name = role_vo.name --角色名字
		info.role_id = tostring(role_vo.role_id) --角色id
		info.user_level = tostring(role_vo.level) or "0" --角色等级
		info.vip_level = tostring(role_vo.vip_level) or "0" --vip

		if RoleData.Instance and RoleData.Instance.role_info then
			info.gold = RoleData.Instance.role_info.gold or "0" --角色元宝余额
			info.party_name = RoleData.Instance.role_vo.guild_name or "无" --帮派
		else
			info.gold = "0"
			info.party_name = "无"
		end
		--上报创建角色时间
		info.roleCTime = role_vo.create_time or 0
		
		agent_helper:SubmitExtendData(cjson.encode(info))
		Log("submitInfo=end======" .. cjson.encode(info))

	end
end

--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end
